
/**
 * A class describing a single lock
 *
 * @author  Jyrki Nummenmaa
 * @version 0.1
 * @see     LockManager
 * @see     LockManagerProtocol
 */


public class Lock {

    public static final boolean SHARED = false;
    public static final boolean EXCLUSIVE = true;    

    /** The id of the txn */
    private long txnId;
    /** The number of the item */
    private int itemNo;
    /** Type of lock: one of Lock.SHARED or Lock.EXCLUSIVE */
    private boolean lockType;

    public Lock(long txnId, int itemNo, boolean lockType) {
	this.txnId = txnId;
	this.itemNo = itemNo;
	this.lockType = lockType;
    }

    public long getTxnId() {
	return txnId;
    }
    
    public int getItemNo() {
	return itemNo;
    }
    
    public boolean getLockType() {
	return lockType;
    }
    
    public boolean equals(Lock l){
	if ((l.getTxnId()==txnId) && (l.getItemNo()==itemNo) && (l.getLockType()==lockType))
	    return true;
	else
	    return false;
    }

    public String outputString() {
	if (lockType == SHARED)
	    return("Shared lock, txnId:" + txnId + ",itemNo:" + itemNo);
	else
	    return("Exclusive lock, txnId:" + txnId + ",itemNo:" + itemNo);
    }
}

