
import java.util.StringTokenizer;

/**
 * A class describing a single waits-for fact
 *
 * @author  Jyrki Nummenmaa
 * @version 0.1
 * @see     LockManager
 */


public class WaitsFor {

    /** pending lock request */
    private Lock waiting;
    
    /** existing lock, whose release the request needs */
    private Lock holding;

    public WaitsFor(Lock waiting, Lock holding) {
	this.waiting = waiting;
	this.holding = holding;
    }

    public WaitsFor(String s) throws Exception {
	StringTokenizer st = new StringTokenizer(s);
	long txnId;
	int itemNo;
	boolean lockType;
	Boolean lT;
	txnId = Long.parseLong(st.nextToken());
	itemNo = Integer.parseInt(st.nextToken());
	lT = new Boolean(st.nextToken());
	lockType = lT.booleanValue();
	waiting = new Lock(txnId, itemNo, lockType);
	txnId = Long.parseLong(st.nextToken());
	itemNo = Integer.parseInt(st.nextToken());
	lT = new Boolean(st.nextToken());
	lockType = lT.booleanValue();
	holding = new Lock(txnId, itemNo, lockType);
    }

    public Lock getWaiting() {
	return waiting;
    }
    
    public Lock getHolding() {
	return holding;
    }
    
    public String toString() {
	return waiting.getTxnId() + " " + waiting.getItemNo() + " " + waiting.getLockType() + " " +
	    holding.getTxnId() + " " + holding.getItemNo() + " " + waiting.getLockType();
    }

    
}

